#include <amxmodx>
#include <amxmisc>
#include <colorchat>

#define MAX_PLAYERS 32
#define MAX_PREFIX_LENGTH 32
#define CONFIG_FILE "addons/amxmodx/configs/prefixcfg/Prefix_Settings.txt"

new g_szPlayerPrefix[MAX_PLAYERS + 1][MAX_PREFIX_LENGTH]

public plugin_init() {
    register_plugin("Custom Prefix System", "1.0", "Maka")
    register_clcmd("say", "handle_say")
    register_clcmd("say_team", "handle_say")
    load_prefixes()
}

public handle_say(id) {
    static szMessage[192], szName[32], szFormattedMsg[192]
    read_args(szMessage, charsmax(szMessage))
    remove_quotes(szMessage)
    
    if (!szMessage[0])
        return PLUGIN_CONTINUE
        
    get_user_name(id, szName, charsmax(szName))
    
    new namePos = containi(szMessage, szName)
    
    if (g_szPlayerPrefix[id][0]) {
        new szBeforeName[192], szAfterName[192]
        
        if (namePos != -1) {
            copy(szBeforeName, namePos, szMessage)
            copy(szAfterName, charsmax(szAfterName), szMessage[namePos])
            format(szFormattedMsg, charsmax(szFormattedMsg), "%s^4[%s]^3 %s", 
                szBeforeName, g_szPlayerPrefix[id], szAfterName)
        } else {
            format(szFormattedMsg, charsmax(szFormattedMsg), "^4[%s]^3 %s^1: %s", 
                g_szPlayerPrefix[id], szName, szMessage)
        }
        
        client_print_color(0, szFormattedMsg)
        return PLUGIN_HANDLED
    }
    
    return PLUGIN_CONTINUE
}

public client_putinserver(id) {
    g_szPlayerPrefix[id][0] = 0
    
    new szAuthID[35]
    get_user_authid(id, szAuthID, charsmax(szAuthID))
    load_player_prefix(id, szAuthID)
}

public client_disconnect(id) {
    g_szPlayerPrefix[id][0] = 0
}

public load_prefixes() {
    new szFile[256]
    get_configsdir(szFile, charsmax(szFile))
    format(szFile, charsmax(szFile), "%s/prefixcfg/Prefix_Settings.txt", szFile)
    
    if (!file_exists(szFile)) {
        write_file(szFile, "; Format: STEAM_ID ^"PREFIX^"", -1)
        return
    }
}

public load_player_prefix(id, const szAuthID[]) {
    new szFile[256]
    get_configsdir(szFile, charsmax(szFile))
    format(szFile, charsmax(szFile), "%s/prefixcfg/Prefix_Settings.txt", szFile)
    
    new szData[196], szFileAuthID[35], szPrefix[MAX_PREFIX_LENGTH]
    new f = fopen(szFile, "rt")
    
    while (!feof(f)) {
        fgets(f, szData, charsmax(szData))
        
        if (szData[0] == ';' || szData[0] == '^n' || !szData[0])
            continue
            
        parse(szData, szFileAuthID, charsmax(szFileAuthID), szPrefix, charsmax(szPrefix))
        
        if (equal(szAuthID, szFileAuthID)) {
            copy(g_szPlayerPrefix[id], charsmax(g_szPlayerPrefix[]), szPrefix)
            break
        }
    }
    
    fclose(f)
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1031\\ f0\\ fs16 \n\\ par }
*/
